<?php
/*
Plugin Name: Orbigraph Embed
Plugin URI: http://www.orbigraph.com/wordpress/plugin.php
Description: Embed Orbigraphs into your blog posts.
Version: 1.0
Author: Larry Sherman
Author URI: http://www.orbigraph.com/
*/

$orbcount = 0; // unique div for each orbi on this page

/////////////////////////////////
//   install swfobject.js      //
/////////////////////////////////
add_action('wp_head', 'orbigraph_head');

function orbigraph_head()
{
	$path = get_settings('siteurl') . '/wp-content/plugins/orbigraph-embed/swfobject.js';
	echo '<script type="text/javascript" src="' . $path . '"></script>';
	echo "\n";
}

/////////////////////////////////
//   parse content functions   //
/////////////////////////////////
add_filter('the_content', 'orbigraph_parse');

function orbigraph_parse($content)
{
	$content = preg_replace_callback( "/(<p>)?\[orbigraph:([^]]+)](<\/p>)?/i", "orbigraph_embed", $content );
	return $content;
}

/////////
//
// replace [orbigraph ...] signature with embed code
//
function orbigraph_embed($matches)
{
	global $orbcount;

	// strip html tags (and brackets)
	$input0 = $matches[2];
	$input1 = preg_replace('!\<[^\>]+\>!',' ',$input0);
	$input2 = preg_replace('!\s+!',' ',$input1);

	// find parts
	preg_match_all("!\s*(.*)\s+(\d+)\s+(\d+)\s*((\{.*\}.*\{/.*\})*)!",$input2,$match);
  	$m_name = $match[1][0];
  	$m_width = $match[2][0];
  	$m_height = $match[3][0];
  	$m_command = $match[4][0]; // {cmd1}{/cmd1} ...

	// check syntax
	if(($m_name == null) || ($m_height == null))
	{
 		return '<p>[ORBIGRAPH] ERROR: Parameter syntax.<br />Refer to <a
href="http://www.orbigraph.com/wordpress/plugin.php" target="_blank">Orbigraph plugin information page</a>.</p>';
	}

	$orbcount++; // make unique id

	//
	// look for wp* theme commands
	//
	$m_preload = "";
	preg_match_all("!\{wppreload\}(.*)\{/wppreload\}!i",$m_command,$match);
	if($match[0][0] != null) { $m_preload = $match[1][0]; }

	$bg = "#";
	preg_match_all("!\{wpswfbgnd\}(.*)\{/wpswfbgnd\}!i",$m_command,$match);
	if($match[0][0] != null)
	{
		$bg .= $match[1][0];
		$bg = strtolower($bg);
	}
	$m_swfbgnd = '#000000';
	if(($bg != "#")&&($bg != '#none')) { $m_swfbgnd = $bg; }

	$m_xparent = ($bg != '#none')? "" : "\n\tso" . $orbcount . ".addParam('wmode','transparent');";

	ob_start();	
	print <<< JS

<div id="orbigraph{$orbcount}"></div>
<script type="text/javascript">
	var so{$orbcount} = new SWFObject('$m_name','orbigraph','$m_width','$m_height','8','$m_swfbgnd');
	so{$orbcount}.addVariable('XMLtoPARSE', '$m_command');
	so{$orbcount}.addVariable('preloaderColor','$m_preload');$m_xparent
	so{$orbcount}.write('orbigraph{$orbcount}');
</script>

JS;

   $output = ob_get_contents();
   ob_end_clean();
	return $output;
}
?>
